package jp.haw.grain.transform.transformer;

import jp.haw.grain.transform.GudBuilder;
import jp.haw.grain.transform.util.Util;
import jp.haw.grain.xpath.compiler.ParseException;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class Bind2Bind extends AbstractTransformer {
	public Bind2Bind(GudBuilder builder) {
		super(builder);
	}


	public Element getCurrentElement() {
		return this.current;
	}

	protected boolean isTarget(Node node) {
		if(node.getNodeType() != Node.ELEMENT_NODE) return false;
		
		Element e = (Element)node;
		if(e.getNamespaceURI() != GudBuilder.XFORMS_NS) return false;
		
		return e.getLocalName().equals("bind");
	}

	public DocumentFragment transform() {
		Document dom = builder.getGudDoc();
		DocumentFragment df = dom.createDocumentFragment();
		Element gud_bind = dom.createElementNS(GudBuilder.GUD_NS, "bind");
		Element xforms_bind = (Element)node;

		//gudvfxformsvf̑Rs[
		//ref΃oCgR[hɓWJ
		Util.copyAttributes(xforms_bind, gud_bind);
		try {
			Util.compileNodeBinding(gud_bind);
		} catch (ParseException e) {
			throw new RuntimeException(e);
		}

		//type̒lύX
		//܂sproutGWinteger, string, boolʕs\
		NamedNodeMap attrs = gud_bind.getAttributes();
		Attr type = (Attr)attrs.getNamedItem("type");
		if(type != null) {
			String value = type.getNodeValue();
			if("xsd:integer".equals(value)) {
				type.setNodeValue("number");
			} else if("xsd:boolean".equals(value)) {
				type.setNodeValue("bool");
			} else {
				type.setNodeValue("string");
			}
		}
		
		this.current = gud_bind;
		df.appendChild(gud_bind);
		return df;
	}

}
